/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.admin.client.paramchooser;

import com.gwtext.client.widgets.Component;
import com.gwtext.client.widgets.Panel;
import com.gwtext.client.widgets.form.Field;
import com.gwtext.client.widgets.form.TextField;
import com.gwtext.client.widgets.form.event.TextFieldListenerAdapter;
import com.gwtext.client.widgets.layout.AnchorLayoutData;
import com.gwtext.client.widgets.layout.FormLayout;
import com.gwtext.client.widgets.tree.TreePanel;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public class TextChooser extends AbstractParamChooser {
	
	protected TreePanel mTreePanel = new TreePanel();

	/* (non-Javadoc)
	 * @see org.appspy.admin.client.paramchooser.ParamChooser#getChooserComponent()
	 */
	public Component getChooserComponent() {
		Panel p = new Panel();
		p.setFrame(true);
		p.setLayout(new FormLayout());
		
		TextField textField = new TextField("Value");
		textField.addListener(new TextFieldListenerAdapter(){

			@Override
			public void onChange(Field field, Object newVal, Object oldVal) {
				setValue(newVal.toString());
			}});
		p.add(textField, new AnchorLayoutData("100%"));
		textField.setValue(getValue());
		
		return p;
	}

	/* (non-Javadoc)
	 * @see org.appspy.admin.client.paramchooser.ParamChooser#updateTextField(com.gwtext.client.widgets.form.TextField)
	 */
	public void updateTextField(final TextField textField) {
		textField.setValue(getValue());
	}
	
	
}
