/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.admin.client.reports.form;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public class DashboardForm implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	protected Long mId;
	protected String mName;
	protected ReportCategoryForm mCategory;
	protected Set<ReportParamForm> mParams = new HashSet<ReportParamForm>();
	protected Set<DashboardColumnForm> mColumns = new HashSet<DashboardColumnForm>();
	/**
	 * @return the dashboardId
	 */
	public Long getId() {
		return mId;
	}
	/**
	 * @param dashboardId the dashboardId to set
	 */
	public void setId(Long dashboardId) {
		this.mId = dashboardId;
	}
	/**
	 * @return the dashboardName
	 */
	public String getName() {
		return mName;
	}
	/**
	 * @param dashboardName the dashboardName to set
	 */
	public void setName(String dashboardName) {
		this.mName = dashboardName;
	}
	/**
	 * @return the reportCategory
	 */
	public ReportCategoryForm getCategory() {
		return mCategory;
	}
	/**
	 * @param reportCategory the reportCategory to set
	 */
	public void setCategory(ReportCategoryForm reportCategory) {
		this.mCategory = reportCategory;
	}
	/**
	 * @return the dashboardParams
	 */
	public Set<ReportParamForm> getParams() {
		return mParams;
	}
	/**
	 * @param dashboardParams the dashboardParams to set
	 */
	public void setParams(Set<ReportParamForm> dashboardParams) {
		this.mParams = dashboardParams;
	}
	/**
	 * @return the dashboardColumns
	 */
	public Set<DashboardColumnForm> getColumns() {
		return mColumns;
	}
	/**
	 * @param dashboardColumns the dashboardColumns to set
	 */
	public void setColumns(Set<DashboardColumnForm> dashboardColumns) {
		this.mColumns = dashboardColumns;
	}
}
