/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.admin.client.rpc;

import java.util.Collection;

import org.appspy.admin.client.reports.form.DashboardForm;
import org.appspy.admin.client.reports.form.ReportCategoryForm;
import org.appspy.admin.client.reports.form.ReportForm;
import org.appspy.admin.client.reports.form.ReportParamChooserForm;
import org.appspy.admin.client.reports.form.ReportingSystemForm;
import org.appspy.admin.client.settings.form.ApplicationForm;
import org.appspy.admin.client.settings.form.ApplicationVersionForm;
import org.appspy.admin.client.settings.form.EnvironmentForm;
import org.appspy.admin.client.settings.form.HostForm;
import org.appspy.admin.client.settings.form.OrganizationForm;

import com.google.gwt.user.client.rpc.RemoteService;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public interface AdminModuleService extends RemoteService {

	public EnvironmentForm saveEnvironment(EnvironmentForm envForm);
	public EnvironmentForm updateEnvironment(EnvironmentForm envForm);
	public void deleteEnvironment(EnvironmentForm environmentForm);
	public Collection<EnvironmentForm> getEnvironments();
	
	public OrganizationForm saveOrganization(OrganizationForm orgForm);
	public OrganizationForm updateOrganization(OrganizationForm orgForm);
	public void deleteOrganization(OrganizationForm orgForm);
	public Collection<OrganizationForm> getOrganizations();
	
	public HostForm saveHost(HostForm hostForm);
	public HostForm updateHost(HostForm hostForm);
	public void deleteHost(HostForm hostForm);
	public Collection<HostForm> getHosts();
	
	public ApplicationForm saveApplication(ApplicationForm appForm);
	public ApplicationForm updateApplication(ApplicationForm appForm);
	public void deleteApplication(ApplicationForm appForm);
	public Collection<ApplicationForm> getApplications();
	
	public ApplicationVersionForm saveVersion(ApplicationVersionForm verForm);
	public ApplicationVersionForm updateVersion(ApplicationVersionForm verForm);
	public void deleteVersion(ApplicationVersionForm verForm);
	public Collection<ApplicationVersionForm> getVersions();
	
	public ReportCategoryForm saveReportCategory(ReportCategoryForm catForm);
	public ReportCategoryForm updateReportCategory(ReportCategoryForm catForm);
	public void deleteReportCategory(ReportCategoryForm catForm);
	public Collection<ReportCategoryForm> getReportCategories();
	
	public ReportForm saveReport(ReportForm reportForm);
	public ReportForm updateReport(ReportForm reportForm);
	public void deleteReport(ReportForm reportForm);
	public Collection<ReportForm> getReports();
	
	public DashboardForm saveDashboard(DashboardForm dashboardForm);
	public DashboardForm updateDashboard(DashboardForm dashboardForm);
	public void deleteDashboard(DashboardForm dashboardForm);
	public Collection<DashboardForm> getDashboards();
	public DashboardForm getDashboard(Long dashboardId);
	
	public Collection<ReportingSystemForm> getReportingSystems();
	
	public Collection<ReportParamChooserForm> getReportParamChoosers();
}
