/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.admin.client.rpc;

import java.util.Collection;

import org.appspy.admin.client.reports.form.DashboardForm;
import org.appspy.admin.client.reports.form.ReportCategoryForm;
import org.appspy.admin.client.reports.form.ReportForm;
import org.appspy.admin.client.reports.form.ReportParamChooserForm;
import org.appspy.admin.client.reports.form.ReportingSystemForm;
import org.appspy.admin.client.settings.form.ApplicationForm;
import org.appspy.admin.client.settings.form.ApplicationVersionForm;
import org.appspy.admin.client.settings.form.EnvironmentForm;
import org.appspy.admin.client.settings.form.HostForm;
import org.appspy.admin.client.settings.form.OrganizationForm;

import com.google.gwt.user.client.rpc.AsyncCallback;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public interface AdminModuleServiceAsync {

	public void saveEnvironment(EnvironmentForm envForm, AsyncCallback<EnvironmentForm> callback);
	public void updateEnvironment(EnvironmentForm envForm, AsyncCallback<EnvironmentForm> callback);
	public void deleteEnvironment(EnvironmentForm environmentForm, AsyncCallback<?> callback);
	public void getEnvironments(AsyncCallback<Collection<EnvironmentForm>> callback);
	
	public void saveOrganization(OrganizationForm orgForm, AsyncCallback<OrganizationForm> callback);
	public void updateOrganization(OrganizationForm orgForm, AsyncCallback<OrganizationForm> callback);
	public void deleteOrganization(OrganizationForm orgForm, AsyncCallback<?> callback);
	public void getOrganizations(AsyncCallback<Collection<OrganizationForm>> callback);
	
	public void saveHost(HostForm hostForm, AsyncCallback<HostForm> callback);
	public void updateHost(HostForm hostForm, AsyncCallback<HostForm> callback);
	public void deleteHost(HostForm hostForm, AsyncCallback<?> callback);
	public void getHosts(AsyncCallback<Collection<HostForm>> callback);
	
	public void saveApplication(ApplicationForm appForm, AsyncCallback<ApplicationForm> callback);
	public void updateApplication(ApplicationForm appForm, AsyncCallback<ApplicationForm> callback);
	public void deleteApplication(ApplicationForm appForm, AsyncCallback<?> callback);
	public void getApplications(AsyncCallback<Collection<ApplicationForm>> callback);
	
	public void saveVersion(ApplicationVersionForm verForm, AsyncCallback<ApplicationVersionForm> callback);
	public void updateVersion(ApplicationVersionForm verForm, AsyncCallback<ApplicationVersionForm> callback);
	public void deleteVersion(ApplicationVersionForm verForm, AsyncCallback<?> callback);
	public void getVersions(AsyncCallback<Collection<ApplicationVersionForm>> callback);
	
	public void saveReportCategory(ReportCategoryForm catForm, AsyncCallback<ReportCategoryForm> callback);
	public void updateReportCategory(ReportCategoryForm catForm, AsyncCallback<ReportCategoryForm> callback);
	public void deleteReportCategory(ReportCategoryForm catForm, AsyncCallback<?> callback);
	public void getReportCategories(AsyncCallback<Collection<ReportCategoryForm>> callback);
	
	public void saveReport(ReportForm reportForm, AsyncCallback<ReportForm> callback);
	public void updateReport(ReportForm reportForm, AsyncCallback<ReportForm> callback);
	public void deleteReport(ReportForm reportForm, AsyncCallback<?> callback);
	public void getReports(AsyncCallback<Collection<ReportForm>> callback);
	
	public void saveDashboard(DashboardForm dashboardForm, AsyncCallback<DashboardForm> callback);
	public void updateDashboard(DashboardForm dashboardForm, AsyncCallback<DashboardForm> callback);
	public void deleteDashboard(DashboardForm dashboardForm, AsyncCallback<?> callback);
	public void getDashboards(AsyncCallback<Collection<DashboardForm>> callback);
	public void getDashboard(Long dashboardId, AsyncCallback<DashboardForm> callback);
	
	public void getReportingSystems(AsyncCallback<Collection<ReportingSystemForm>> callback);
	
	public void getReportParamChoosers(AsyncCallback<Collection<ReportParamChooserForm>> callback);
}
